weka.estimators

## Class NormalEstimator

- java.lang.Object
- - weka.estimators.Estimator
  - - weka.estimators.NormalEstimator

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, Aggregateable<NormalEstimator>, CapabilitiesHandler, CapabilitiesIgnorer, OptionHandler, RevisionHandler, IncrementalEstimator

      public class NormalEstimator
      extends Estimator
      implements IncrementalEstimator, Aggregateable<NormalEstimator>

  Simple probability estimator that places a single normal distribution over the observed values.
  Version:
    $Revision: 9785 $
  Author:
    Len Trigg (trigg@cs.waikato.ac.nz)
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `NormalEstimator(double precision)` Constructor that takes a precision argument.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addValue(double data, double weight)` Add a new data value to the current estimator.
    `NormalEstimator` | `aggregate(NormalEstimator toAggregate)` Aggregate an object with this one
    `void` | `finalizeAggregation()` Call to complete the aggregation process.
    `Capabilities` | `getCapabilities()` Returns default capabilities of the classifier.
    `double` | `getMean()` Return the value of the mean of this normal estimator.
    `double` | `getPrecision()` Return the value of the precision of this normal estimator.
    `double` | `getProbability(double data)` Get a probability estimate for a value
    `java.lang.String` | `getRevision()` Returns the revision string.
    `double` | `getStdDev()` Return the value of the standard deviation of this normal estimator.
    `double` | `getSumOfWeights()` Return the sum of the weights for this normal estimator.
    `static void` | `main(java.lang.String[] argv)` Main method for testing this class.
    `static void` | `testAggregation()`
    `java.lang.String` | `toString()` Display a representation of this estimator

    - ### Methods inherited from class weka.estimators.Estimator

      `addValues, addValues, addValues, addValues, buildEstimator, buildEstimator, clone, debugTipText, doNotCheckCapabilitiesTipText, equals, forName, getDebug, getDoNotCheckCapabilities, getOptions, listOptions, makeCopies, makeCopy, setDebug, setDoNotCheckCapabilities, setOptions, testCapabilities`

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### NormalEstimator

          public NormalEstimator(double precision)

      Constructor that takes a precision argument.
      Parameters:
        `precision` - the precision to which numeric values are given. For example, if the precision is stated to be 0.1, the values in the interval (0.25,0.35] are all treated as 0.3.

  - ### Method Detail

    - #### addValue

          public void addValue(double data,
                               double weight)

      Add a new data value to the current estimator.
      Specified by:
        `addValue` in interface `IncrementalEstimator`
      Overrides:
        `addValue` in class `Estimator`
      Parameters:
        `data` - the new data value
        `weight` - the weight assigned to the data value

    - #### getProbability

          public double getProbability(double data)

      Get a probability estimate for a value
      Specified by:
        `getProbability` in class `Estimator`
      Parameters:
        `data` - the value to estimate the probability of
      Returns:
        the estimated probability of the supplied value

    - #### toString

          public java.lang.String toString()

      Display a representation of this estimator
      Overrides:
        `toString` in class `java.lang.Object`

    - #### getCapabilities

          public Capabilities getCapabilities()

      Returns default capabilities of the classifier.
      Specified by:
        `getCapabilities` in interface `CapabilitiesHandler`
      Overrides:
        `getCapabilities` in class `Estimator`
      Returns:
        the capabilities of this classifier
      See Also:
        `Capabilities`

    - #### getMean

          public double getMean()

      Return the value of the mean of this normal estimator.
      Returns:
        the mean

    - #### getStdDev

          public double getStdDev()

      Return the value of the standard deviation of this normal estimator.
      Returns:
        the standard deviation

    - #### getPrecision

          public double getPrecision()

      Return the value of the precision of this normal estimator.
      Returns:
        the precision

    - #### getSumOfWeights

          public double getSumOfWeights()

      Return the sum of the weights for this normal estimator.
      Returns:
        the sum of the weights

    - #### getRevision

          public java.lang.String getRevision()

      Returns the revision string.
      Specified by:
        `getRevision` in interface `RevisionHandler`
      Overrides:
        `getRevision` in class `Estimator`
      Returns:
        the revision

    - #### aggregate

          public NormalEstimator aggregate(NormalEstimator toAggregate)
                                    throws java.lang.Exception

      Description copied from interface: `Aggregateable`
      Aggregate an object with this one
      Specified by:
        `aggregate` in interface `Aggregateable<NormalEstimator>`
      Parameters:
        `toAggregate` - the object to aggregate
      Returns:
        the result of aggregation
      Throws:
        `java.lang.Exception` - if the supplied object can't be aggregated for some reason

    - #### finalizeAggregation

          public void finalizeAggregation()
                                   throws java.lang.Exception

      Description copied from interface: `Aggregateable`
      Call to complete the aggregation process. Allows implementers to do any final processing based on how many objects were aggregated.
      Specified by:
        `finalizeAggregation` in interface `Aggregateable<NormalEstimator>`
      Throws:
        `java.lang.Exception` - if the aggregation can't be finalized for some reason

    - #### testAggregation

          public static void testAggregation()

    - #### main

          public static void main(java.lang.String[] argv)

      Main method for testing this class.
      Parameters:
        `argv` - should contain a sequence of numeric values